Subject: Re: Global data in DLL's how?
From: [email-masked] (Fergus Henderson)

25 May 1998 06:33:57 -0700
Message-ID: <[email-masked]>
References: <[email-masked]>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
To: [email-masked]
Cc: Craig Setera <[email-masked]>, [email-masked]

On 23-May-1998, Steve Biskis <[email-masked]> wrote:
> I don't know if the Gnu/Cygnus development environment
> supports this but the MS prescribed way to change the
> default behavior of globals so that they may be shared
> by all attached processes is to add a directive like the
> following to your DLL's entry module:
> 
> #pragma data_seg( ".GLOBALS" )
> int nProcesses =0;
> int nThreads     =0;
> #pragma data_seg()

The gcc equivalent of this would be

	int nProcesses __attribute__((section(".GLOBALS")) = 0;
	int nThreads __attribute__((section(".GLOBALS")) = 0;

However, I have no idea whether this works.

I do know that the technique of using

	#define nProcesses (*__imp_nProcesses)

works.  (This technique is automated if you use my Makefile.DLLs,
see <http://www.cs.mu.oz.au/~fjh/gnu-win32/how-to-build-dlls.html>.)

-- 
Fergus Henderson <[email-masked]>  |  "I have always known that the pursuit
WWW: <http://www.cs.mu.oz.au/~fjh>  |  of excellence is a lethal habit"
PGP: finger [email-masked]        |     -- the last words of T. S. Garp.
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".